﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using Syncfusion.DocIO.DLS;
using System.Diagnostics;
using Syncfusion.DocIO;

namespace DocIOApplication
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Loads a template document
            WordDocument wordDocument = new WordDocument(System.Environment.CurrentDirectory + @"\..\..\Data\Template.docx", FormatType.Docx);
            //Gets the ownerparagraph of table of contents
            WParagraph ownerTOC = GetTOCOwnerParagraph(wordDocument);
            //Gets the Text from table of contents
            if (ownerTOC != null)
            {
                StringBuilder stringBuilder = new StringBuilder();
                //Iterate the paragraph item starting from the field start mark to the field end mark of the particular TOC field.
                while (ownerTOC.NextSibling is WParagraph && FieldItemCheck(ownerTOC))
                {
                    for (int i = 0; i < ownerTOC.Items.Count; i++)
                    {
                        if (ownerTOC.Items[i].EntityType == EntityType.TextRange)
                        {
                            stringBuilder.Append((ownerTOC.Items[i] as WTextRange).Text);
                        }
                    }
                    ownerTOC = ownerTOC.NextSibling as WParagraph;
                    stringBuilder.AppendLine();
                }
                MessageBox.Show(stringBuilder.ToString());
            }
            else
            {
                MessageBox.Show("No TOC exists.");
            }
        }
        #region Helper Methods
        /// <summary>
        /// Gets owner paragraph of TOC from WordDocument.
        /// </summary>
        /// <param name="wordDocument">The Word Document</param>
        /// <returns></returns>
        private WParagraph GetTOCOwnerParagraph(WordDocument wordDocument)
        {
            bool isTOC = false;
            foreach (WParagraph wParagraph in wordDocument.Sections[0].Paragraphs)
            {
                foreach (ParagraphItem paraItem in wParagraph.Items)
                    if (paraItem.EntityType == EntityType.TOC)
                        return paraItem.OwnerParagraph;
            }
            return null;
        }
        /// <summary>
        /// Check whether the paragraph contains field mark
        /// </summary>
        /// <param name="paragraph"></param>
        /// <returns></returns>
        private bool FieldItemCheck(WParagraph paragraph)
        {
            for (int i = 0; i < paragraph.Items.Count; i++)
            {
                if (paragraph.Items[i] is WFieldMark)
                {
                    return true;
                    break;
                }
            }
            return false;
        }
        #endregion Helper Methods
    }
}
